#### Previous topic

scipy.spatial.KDTree.query_ball_tree

#### Next topic

scipy.spatial.KDTree.sparse_distance_matrix

# scipy.spatial.KDTree.query_pairs

`KDTree.``query_pairs`(r, p=2.0, eps=0)

  Find all pairs of points within a distance.

  Parameters:

  r : positive float

  > The maximum distance.

  p : float, optional

  > Which Minkowski norm to use. p has to meet the condition `1 <= p <= infinity`.

  eps : float, optional

  > Approximate search. Branches of the tree are not explored if their nearest points are further than `r/(1+eps)`, and branches are added in bulk if their furthest points are nearer than `r * (1+eps)`. eps has to be non-negative.

  Returns:

  results : set

  > Set of pairs `(i,j)`, with `i < j`, for which the corresponding positions are close.